"use strict";

exports.__esModule = true;
exports.default = void 0;

var _inject = _interopRequireDefault(require("./vdom/inject"));

var _instance = _interopRequireDefault(require("./vdom/instance"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function render(element, container, options, callback) {
  // Compatible with `render(element, container, callback)`
  if (typeof options === 'function') {
    callback = options;
    options = null;
  }

  options = options || {}; // Init inject

  (0, _inject.default)(options);

  var rootComponent = _instance.default.mount(element, container, options.parent);

  var componentInstance = rootComponent.getPublicInstance();

  if (callback) {
    callback.call(componentInstance);
  }

  return componentInstance;
}

var _default = render;
exports.default = _default;