"use strict";

exports.__esModule = true;
exports.default = renderToString;

var _driverServer = _interopRequireDefault(require("driver-server"));

var _host = _interopRequireDefault(require("../vdom/host"));

var _render = _interopRequireDefault(require("../render"));

var _serializer = _interopRequireDefault(require("./serializer"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RENDERED_NAME = 'data-rendered';
var CACHE_KEY_NAME = 'data-cache-key';
/**
 * Add renered mark to element
 */

function addRenderedMark(element, markedValue) {
  if (!element || !element.attributes) {
    return element;
  }

  element.attributes[RENDERED_NAME] = markedValue;
  return element;
}

function renderToString(element) {
  // Reset driver iternal state
  _driverServer.default.nodeMaps = {}; // Reset host state

  _host.default.rootComponents = {};
  _host.default.rootInstances = {};
  _host.default.mountID = 1;

  var body = _driverServer.default.createBody();

  (0, _render.default)(element, body, {
    driver: _driverServer.default
  }); // Add rendered mark to root ChildNodes

  if (body.childNodes) {
    for (var i = 0; i < body.childNodes.length; i++) {
      body.childNodes[i] = addRenderedMark(body.childNodes[i], 'server');
    }
  }

  var markup = new _serializer.default(body).serialize() || '';
  return markup;
}