"use strict";

exports.__esModule = true;
exports.default = void 0;

var _host = _interopRequireDefault(require("./host"));

var _native = _interopRequireDefault(require("./native"));

var _instance = _interopRequireDefault(require("./instance"));

var _toArray = _interopRequireDefault(require("./toArray"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

/**
 * Fragment Component
 */
var FragmentComponent =
/*#__PURE__*/
function (_NativeComponent) {
  _inheritsLoose(FragmentComponent, _NativeComponent);

  function FragmentComponent() {
    return _NativeComponent.apply(this, arguments) || this;
  }

  var _proto = FragmentComponent.prototype;

  _proto.mountComponent = function mountComponent(parent, parentInstance, context, nativeNodeMounter) {
    this.initComponent(parent, parentInstance, context);
    var instance = {
      _internal: this
    };
    this._instance = instance; // Mount children

    this.mountChildren(this._currentElement, context);
    var fragment = this.getNativeNode();

    if (nativeNodeMounter) {
      nativeNodeMounter(fragment, parent);
    } else {
      for (var i = 0; i < fragment.length; i++) {
        _host.default.driver.appendChild(fragment[i], parent);
      }
    }

    return instance;
  };

  _proto.mountChildren = function mountChildren(children, context) {
    var fragment = this.getNativeNode();
    return this._mountChildren(this._parent, children, context, function (nativeNode) {
      nativeNode = (0, _toArray.default)(nativeNode);

      for (var i = 0; i < nativeNode.length; i++) {
        fragment.push(nativeNode[i]);
      }
    });
  };

  _proto.unmountComponent = function unmountComponent(shouldNotRemoveChild) {
    var nativeNode = this._nativeNode;

    if (nativeNode) {
      _instance.default.remove(nativeNode);

      if (!shouldNotRemoveChild) {
        for (var i = 0; i < nativeNode.length; i++) {
          _host.default.driver.removeChild(nativeNode[i]);
        }
      }
    } // Do not need remove child when their parent is removed


    this.unmountChildren(true);
    this.destoryComponent();
  };

  _proto.updateComponent = function updateComponent(prevElement, nextElement, prevContext, nextContext) {
    // Replace current element
    this._currentElement = nextElement;
    this.updateChildren(this._currentElement, nextContext);
  };

  _proto.createNativeNode = function createNativeNode() {
    return [];
  };

  _proto.getName = function getName() {
    return 'fragment';
  };

  return FragmentComponent;
}(_native.default);

var _default = FragmentComponent;
exports.default = _default;