"use strict";

exports.__esModule = true;
exports.default = void 0;

var _default = function _default(children, element, index) {
  var elementKey = element && element.key;
  var defaultName = '.' + index.toString(36); // Inner child name default format fallback
  // Key should must be string type

  if (typeof elementKey === 'string') {
    var keyName = '$' + elementKey; // Child keys must be unique.

    var keyUnique = children[keyName] === undefined; // Only the first child will be used when encountered two children with the same key

    if (!keyUnique) console.warn("Encountered two children with the same key \"" + elementKey + "\".");
    return keyUnique ? keyName : defaultName;
  } else {
    return defaultName;
  }
};

exports.default = _default;