"use strict";

exports.__esModule = true;
exports.flush = flush;
exports.setUpdater = setUpdater;
exports.schedule = void 0;
var performUpdate = null;

var setImmediatePolyfill = function setImmediatePolyfill(job) {
  return setTimeout(job, 0);
}; // 0s


var scheduleImmediateCallback = typeof setImmediate === 'undefined' ? setImmediatePolyfill : setImmediate;
var cancelImmediateCallback = typeof clearImmediate === 'undefined' ? clearTimeout : clearImmediate;
var beforeNextRenderCallbacks = [];
var beforeNextRenderCallbackId; // Commit before next render

function commit() {
  var preCallbacks = beforeNextRenderCallbacks;
  beforeNextRenderCallbacks = [];
  preCallbacks.forEach(function (callback) {
    return callback();
  });
  preCallbacks = null; // Exec callback maybe schedule a work

  performUpdate();
} // Schedule before next render


var schedule = function schedule(callback) {
  if (beforeNextRenderCallbacks.length === 0) {
    beforeNextRenderCallbackId = scheduleImmediateCallback(commit);
  }

  beforeNextRenderCallbacks.push(callback);
}; // Flush before next render


exports.schedule = schedule;

function flush() {
  if (beforeNextRenderCallbacks.length !== 0) {
    cancelImmediateCallback(beforeNextRenderCallbackId);
    commit();
  }
}

function setUpdater(handle) {
  performUpdate = handle;
}