"use strict";

exports.__esModule = true;
exports.default = void 0;

function shouldUpdateComponent(prevElement, nextElement) {
  var prevEmpty = prevElement === null;
  var nextEmpty = nextElement === null;

  if (prevEmpty || nextEmpty) {
    return prevEmpty === nextEmpty;
  }

  var prevType = typeof prevElement;
  var nextType = typeof nextElement;

  if (prevType === 'string' || prevType === 'number') {
    return nextType === 'string' || nextType === 'number';
  } else {
    // prevElement and nextElement could be array, typeof [] is "object"
    return prevType === 'object' && nextType === 'object' && prevElement.type === nextElement.type && prevElement.key === nextElement.key;
  }
}

var _default = shouldUpdateComponent;
exports.default = _default;