"use strict";

exports.__esModule = true;
exports.default = void 0;

var _host = _interopRequireDefault(require("./host"));

var _base = _interopRequireDefault(require("./base"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

/**
 * Text Component
 */
var TextComponent =
/*#__PURE__*/
function (_BaseComponent) {
  _inheritsLoose(TextComponent, _BaseComponent);

  function TextComponent() {
    return _BaseComponent.apply(this, arguments) || this;
  }

  var _proto = TextComponent.prototype;

  _proto.updateComponent = function updateComponent(prevElement, nextElement, context) {
    nextElement = String(nextElement); // If text is some value that do not update even there number 1 and string "1"

    if (prevElement !== nextElement) {
      // Replace current element
      this._currentElement = nextElement;

      _host.default.driver.updateText(this.getNativeNode(), this._currentElement);

      if (process.env.NODE_ENV !== 'production') {
        _host.default.hook.Reconciler.receiveComponent(this);
      }
    }
  };

  _proto.createNativeNode = function createNativeNode() {
    return _host.default.driver.createText(this._currentElement);
  };

  return TextComponent;
}(_base.default);

var _default = TextComponent;
exports.default = _default;